.486
.model flat, stdcall

option 	casemap: none

include 	\masm32\include\windows.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\masm32.inc
include		combine.inc
includelib 	\masm32\lib\kernel32.lib
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\masm32.lib
GetCombineINI	PROTO	STDCALL
CloseFiles		PROTO	STDCALL
ProcessSection	PROTO	STDCALL :DWORD, :DWORD
FindSourceLine	PROTO	STDCALL :DWORD, :DWORD
GetSectionIDFromLine PROTO STDCALL :DWORD, :DWORD
.data
	;--- Displayed text data ---
	IntroText			db	"--------------------------------------------------------------------------------"
						db	"        Combiner 3.0 - (C) Copyright 2001 by Exagone. All rights reserved       "
						db	"--------------------------------------------------------------------------------"
	IntroTextlen		equ	$-IntroText
	
	ErrNoINI			db	"ERROR: Could not open combine.ini.",0dh,0ah
	ErrNoINIlen 		equ	$-ErrNoINI
	
	ErrNoLoad			db	"ERROR: Could not open file: "
	ErrNoLoadlen 		equ	$-ErrNoLoad
	
	ErrNoSave			db	"ERROR: Could not create destination file.",0dh,0ah
	ErrNoSavelen 		equ	$-ErrNoSave
	
	ErrNoLIF			db	"ERROR: Could not create line information file.",0dh,0ah
	ErrNoLIFlen			equ $-ErrNoLIF
		
;	ErrNoAlloc			db	"ERROR: Could not allocate enough memory.",0dh,0ah
;	ErrNoAlloclen 	equ		$-ErrNoAlloc
;	
;	ErrNoLock			db	"ERROR: Failed to lock memory.",0dh,0ah
;	ErrNoLocklen  	equ		$-ErrNoLock
	
	
	EnterText			db	0dh,0ah

	;--- INI file data ---
	INISectionFiles		db	"Files",0
	INIKeyFileFormat	db	"File%lu",0
	INIKeyDestination	db	"Destination",0
	INIKeyLineInfo		db	"LineInfo",0
	DefaultString		db	"N/A!",0
	
	; --- Section data ---
	SectionBlank		db	0			;should be always the first
	SectionConst		db	".const",0  ;ALL IN LOWERCASE!!!
	SectionUData		db	".data?",0
	SectionIData		db	".data",0
	SectionCode			db	".code",0
	NROFSECTIONS		equ		5
	SectionTable		dd	offset SectionBlank, offset SectionConst
						dd	offset SectionUData, offset SectionIData
						dd	offset SectionCode
	
.data?
 	;--- Module handle ---
	hInstance			dd		?
	
	;--- Standard handles ---
	STDError			dd		?
	STDOutput			dd		?
	STDInput			dd		?

	;--- flags ---
	fLineInfoFile		db		?				;line info file used?
	
	;--- File function data ---
	BytesWritten		dd		?
	BytesRead			dd		?
	INIFileName			db		260 dup (?)
	hDestination		dd		?				;destination asm file handle
	hLineInfoFile		dd		?				;line info file handle
	
	;--- source file handle table ---
	hSourceFiles		dd		200 dup (?)		;max 200 source files!
	NrOfFiles			dd		?
	
	;--- Line info file data ---
	LIFStdHeader			LINEINFOFILE_HEADER <?>
	CurrentDestinationLine	dd					 ?
.code
start:
;------------------------------------------------------------------------------------------
; Initialize
;------------------------------------------------------------------------------------------
	invoke 	GetModuleHandle, NULL
	mov		hInstance, eax
	
;------------------------------------------------------------------------------------------
; Get Standard Handles
;------------------------------------------------------------------------------------------
	mov 	hInstance, eax
    invoke	GetStdHandle, STD_ERROR_HANDLE
	mov		STDError, eax
	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov		STDOutput, eax
	invoke	GetStdHandle, STD_INPUT_HANDLE
	mov		STDInput, eax
;------------------------------------------------------------------------------------------
; Show Intro
;------------------------------------------------------------------------------------------	
	invoke	WriteFile, STDOutput, ADDR IntroText, IntroTextlen, ADDR BytesWritten, 0 
;------------------------------------------------------------------------------------------
; Load info from ini file
;------------------------------------------------------------------------------------------		
	invoke	GetCombineINI
	.IF		eax==0 ;failed?
		invoke	ExitProcess, 1
	.ENDIF
;------------------------------------------------------------------------------------------
; Initialize processing
;------------------------------------------------------------------------------------------		
	and		CurrentDestinationLine, 0
	inc		CurrentDestinationLine
;------------------------------------------------------------------------------------------
; Process each section
;------------------------------------------------------------------------------------------		


	xor		ebx, ebx
	.WHILE	ebx<NROFSECTIONS
		mov		eax, offset SectionTable
		mov		eax, [eax+ebx*4]
		invoke	ProcessSection, eax, ebx
	inc	ebx
	.ENDW
	
	
;------------------------------------------------------------------------------------------
; Quit
;------------------------------------------------------------------------------------------	
	invoke	CloseFiles
	invoke	ExitProcess, 0


;==========================================================================================
; ProcessSection
;==========================================================================================
ProcessSection	proc uses esi edi ebx lpSectionName:DWORD, lpSectionID:DWORD
LOCAL	hCurrentSourceFile:DWORD
LOCAL	CurrentSourceLine:DWORD
LOCAL	hFileMapping:DWORD
LOCAL	pFileMapping:DWORD
LOCAL	dwCurrentFile:DWORD
LOCAL	dwCurrentSectionID:DWORD ;id of section we're currently in
LOCAL	fLineNumbersChanged:DWORD
	;--- first write section name to file if needed ---
	.IF		lpSectionID!=0 ;if not blank section
		invoke	lstrlen, lpSectionName
		mov		ecx, eax
		invoke	WriteFile, hDestination, lpSectionName, eax, ADDR BytesWritten, 0
		invoke	WriteFile, hDestination, ADDR EnterText, 2, ADDR BytesWritten, 0
		inc	CurrentDestinationLine
	.ENDIF
	
	xor		ebx, ebx ;filecounter
	.WHILE	ebx<NrOfFiles
		mov		dwCurrentFile, ebx ;save ebx
		mov		eax, [offset hSourceFiles+ebx*4]
		mov		hCurrentSourceFile, eax
		; --- create a readable file mapping of the source file ---
		invoke	CreateFileMapping, hCurrentSourceFile, NULL, PAGE_READONLY, 0, 0, NULL
		mov		hFileMapping, eax
		invoke	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
		mov		pFileMapping, eax
		
		;--- actual file processing in this loop ---
		and		CurrentSourceLine, 0
		and		dwCurrentSectionID, 0
		mov		fLineNumbersChanged, 1
		inc		CurrentSourceLine
		mov		esi, pFileMapping 	;esi points to file data
		invoke	GetFileSize, hCurrentSourceFile, NULL 
		mov		edi, eax
		add		edi, esi 			;edi points to end of file 
		.WHILE	TRUE
			;---process line by line ---
			invoke	FindSourceLine, esi, edi
			;---eax contains number of bytes in current line, ecx---
			;---contains pointer to start of next line, esi points---
			;---to start of current line ---
			push	ecx
			mov		ebx, eax
			;---check if new section found in this line ---
			invoke	GetSectionIDFromLine, esi, eax
			.IF		eax!=-1 ; if yes, update current section id
				.IF		eax!=dwCurrentSectionID ;section changed? if yes, add new line info if needed
					inc		fLineNumbersChanged
				.ENDIF
				mov		dwCurrentSectionID, eax
			.ELSE
				;---if section is the section we are looking for, add to output file---
				;---NOTE: this is placed in the ELSE of the IF/ENDIF because section---
				;---names are not copied from the source files, they are made by ---
				;---combiner ---
				mov		eax, lpSectionID
				.IF 	eax==dwCurrentSectionID
					;---Save line information if needed and if changed---
					.IF		fLineInfoFile && fLineNumbersChanged
						and		fLineNumbersChanged, 0
						invoke  WriteFile, hLineInfoFile, ADDR CurrentDestinationLine, 4, ADDR BytesWritten, 0
						invoke	WriteFile, hLineInfoFile, ADDR dwCurrentFile, 4, ADDR BytesWritten, 0
						invoke	WriteFile, hLineInfoFile, ADDR CurrentSourceLine, 4, ADDR BytesWritten, 0
					.ENDIF
					;---write line to output file---
					invoke	WriteFile, hDestination, esi, ebx, ADDR BytesWritten, 0
					invoke	WriteFile, hDestination, ADDR EnterText, 2, ADDR BytesWritten, 0
					inc		CurrentDestinationLine
				.ENDIF
			
			.ENDIF
 
			pop		ecx
			mov		esi, ecx
			.IF		esi==0 || esi==edi
				.BREAK
			.ENDIF
			inc		CurrentSourceLine
		.ENDW
		;-------------------------------------------
		
		
		invoke	UnmapViewOfFile, pFileMapping
		invoke	CloseHandle, hFileMapping
		mov		ebx, dwCurrentFile ;restore ebx
	inc		ebx
	.ENDW
xor		eax, eax
inc		eax
ret
ProcessSection	endp

;checks if section started at a line (.code/.data found), returns -1 if no section defined in
;line.
GetSectionIDFromLine	proc uses ebx esi edi lpLine:DWORD, dwLen:DWORD
	mov		esi, lpLine
	mov		edi, dwLen
	add		edi, esi
	.WHILE	esi<edi
		mov		al, [esi]
		.IF		(al!=" ") && (al!=09h) ;no leading space or tab?
			jmp	@leadingspaces_skipped
		.ENDIF
	inc	esi
	.ENDW
	jmp		@no_section
@leadingspaces_skipped:
	.IF		esi==edi ;end of data already reached?
		jmp		@no_section
	.ENDIF
	xor		ebx, ebx
	inc		ebx 		;skip blank section, start at index 1
	;--- loop through sections ---
	.WHILE	ebx<NROFSECTIONS
		mov		ecx, offset SectionTable
		mov		ecx, [ecx+ebx*4]
		push	esi	;save esi for next compare
		.WHILE	1
			mov		al, [ecx]
			.IF		al==0 ;if end of section name reached,
						  ;check if whitespace after section name
				.IF	esi==edi ;end of line after section name?
					jmp		@section_match ;match!
				.ENDIF
				mov	al, [esi]
				.IF	al==" " || al==09h ;whitespace after section name?
					jmp		@section_match ;match!
				.ENDIF
				;if other data directly after section name,
				;it's not a valid section name so no match:
				jmp	@no_match
			.ENDIF
			.IF		esi==edi
				jmp		@no_match
			.ENDIF
			mov		dl, [esi]
			.IF		dl>="A" && dl<="Z" ;for case insensitive compare
				add		dl, ("a"-"A")
			.ENDIF
			.IF		dl!=al
				jmp		@no_match
			.eNDIF
			inc		ecx
			inc		esi	
		.ENDW
		@no_match:
		pop		esi ;restore esi
	inc	ebx
	.ENDW
	jmp		@no_section
@section_match:
	pop		esi
	mov		eax, ebx ;return section ID
ret
@no_section:
	xor		eax, eax
	dec		eax
ret
GetSectionIDFromLine	endp
;==========================================================================================
; Get combine.ini procedure
;==========================================================================================
GetCombineINI proc uses ecx ebx edx esi edi
LOCAL	buffer1[260]:BYTE
LOCAL	buffer2[260]:BYTE
	; --- Construct path&name of combine.ini in current directory---
	invoke 	GetCurrentDirectory, 260, ADDR INIFileName
	mov		ecx, offset INIFileName
	add		ecx, eax
	.IF		byte ptr [ecx-1]!="\"
		mov		byte ptr [ecx],"\"
	.ENDIF
	inc		ecx
	mov 	dword ptr [ecx], "bmoc"
	mov 	dword ptr [ecx+4], ".eni"
	mov 	dword ptr [ecx+8], 00696e69h
	; --- combine.ini file is now in INIFileName ---
	
	
;------------------------------------------------------------------------------------------
; Create destination file
;------------------------------------------------------------------------------------------	
	; --- Get destination filename from ini file in buffer1---
	invoke 	GetPrivateProfileString, ADDR INISectionFiles,ADDR INIKeyDestination,\
			 ADDR DefaultString, ADDR buffer1, 260, ADDR INIFileName	
			 
	; --- get filename ---
	lea		eax, buffer1
	mov 	eax, [eax]
	
	; --- if no ini found, display error and quit ---
	.IF eax=="!A/N"
		invoke	WriteFile, STDError, ADDR ErrNoINI, ErrNoINIlen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	
	; --- Create destination file ---
	invoke 	CreateFile, ADDR buffer1, GENERIC_WRITE, FILE_SHARE_READ, NULL,\
				CREATE_ALWAYS, NULL, NULL
	mov 	hDestination, eax
	.IF 	eax==INVALID_HANDLE_VALUE ;failed? display error and quit
		invoke	WriteFile, STDError, ADDR ErrNoSave, ErrNoSavelen, \
				ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
;------------------------------------------------------------------------------------------
; Create line number info file, if needed
;------------------------------------------------------------------------------------------		
	; --- Get destination filename from ini file in buffer1---
	invoke 	GetPrivateProfileString, ADDR INISectionFiles,ADDR INIKeyLineInfo,\
			 ADDR DefaultString, ADDR buffer1, 260, ADDR INIFileName	
			 
	; --- get filename ---
	lea		eax, buffer1
	mov 	eax, [eax]
	
	; --- reset flag ---
	and		fLineInfoFile,0
	
	; --- if not found, no line number info file is created ---
	.IF eax=="!A/N"
		jmp		@no_linefile
	.ENDIF
	
	; --- set line info file flag ---
	inc		fLineInfoFile
	
	; --- Create line info file ---
	invoke 	CreateFile, ADDR buffer1, GENERIC_WRITE, FILE_SHARE_READ, NULL,\
				CREATE_ALWAYS, NULL, NULL
	mov 	hLineInfoFile, eax
	.IF 	eax==INVALID_HANDLE_VALUE ;failed? display error and quit
		invoke	WriteFile, STDError, ADDR ErrNoLIF, ErrNoLIFlen, \
				ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	mov	LIFStdHeader.dwMagic, 0046494Ch 
	mov	LIFStdHeader.pLineData, SIZEOF LINEINFOFILE_HEADER
		
	; --- Write standard LIF header (blank, will be modified later) ---
	invoke	WriteFile, hLineInfoFile, ADDR LIFStdHeader, SIZEOF LINEINFOFILE_HEADER,\
			ADDR BytesWritten, NULL
			
@no_linefile:	
;------------------------------------------------------------------------------------------
; Get Source filenames and open files
;------------------------------------------------------------------------------------------
	; --- initialize ---
	and 	NrOfFiles, 0
	mov 	ebx, offset hSourceFiles
	; --- loop through all file entries in the ini file ---
	xor 	esi, esi
	.WHILE (esi<200)
		mov eax,esi
		inc eax
		invoke	wsprintf, ADDR buffer1, ADDR INIKeyFileFormat, eax
		invoke GetPrivateProfileString, ADDR INISectionFiles, ADDR buffer1,\
				ADDR DefaultString, ADDR buffer2, 400, ADDR INIFileName
		lea eax, buffer2
		mov eax, [eax]
		.IF eax=="!A/N"
			; no files anymore
			.BREAK					
		.ENDIF
		inc 	NrOfFiles
		invoke 	CreateFile, ADDR buffer2, GENERIC_READ, FILE_SHARE_READ, NULL,\
				OPEN_EXISTING, NULL, NULL
		; --- if file open failed, display message and quit ---
		.IF eax==INVALID_HANDLE_VALUE
				invoke	WriteFile, STDError, ADDR ErrNoLoad, ErrNoLoadlen, \
				ADDR BytesRead, NULL
				invoke lstrlen, ADDR buffer2
				invoke	WriteFile, STDError, ADDR buffer2, eax, \
				ADDR BytesRead, NULL
				jmp		@failed
		.ENDIF
		mov 	[ebx+esi*4],eax
		; --- if line info file is used, add filename to filetable ---
		.IF		fLineInfoFile
			invoke	lnstr, ADDR buffer2
			inc		eax
			invoke	WriteFile, hLineInfoFile, ADDR buffer2, eax, ADDR BytesWritten, 0
			mov		eax, BytesWritten
			add		LIFStdHeader.pLineData, eax
		.ENDIF
		
 	inc esi
	.ENDW
	.IF		fLineInfoFile
		push	NrOfFiles
		pop		LIFStdHeader.dwNrOfFiles
		invoke	SetFilePointer, hLineInfoFile, 0, 0, FILE_BEGIN	
		invoke	WriteFile, hLineInfoFile, ADDR LIFStdHeader, SIZEOF LINEINFOFILE_HEADER,\
			ADDR BytesWritten, NULL
		invoke	SetFilePointer, hLineInfoFile, 0, 0, FILE_END
	.ENDIF	
	
	xor		eax, eax
	inc		eax			;success
ret
@failed:
	invoke	CloseFiles
	xor		eax, eax
ret
GetCombineINI endp 

CloseFiles	proc uses ebx esi
	.IF		hDestination!=0
		invoke	CloseHandle, hDestination
	.ENDIF
	.IF		hLineInfoFile!=0
		invoke	CloseHandle, hLineInfoFile
	.ENDIF
	xor		ebx, ebx
	mov		esi, offset hSourceFiles
	.WHILE	ebx<NrOfFiles
		invoke	CloseHandle, dword ptr [esi+ebx*4]
		inc ebx
	.ENDW
ret
CloseFiles	endp
; ------- FindSourceLine---
; Returns the length of the line at lpStart (not including CR/LF/CRLF) in EAX
; Returns pointer to the next line in ECX
; returns 0 in ecx if this is the last line before lpEnd
FindSourceLine	proc	lpStart:DWORD, lpEnd:DWORD
	mov		edx, lpStart
	mov		ecx, lpEnd
	.WHILE	edx<ecx
		.IF		byte ptr [edx]==0Dh
			mov		eax, edx
			sub		eax, lpStart
			inc		edx
			.IF		edx==ecx ;end?
				xor		ecx, ecx
				ret
			.ENDIF
			.IF		byte ptr [edx]==0Ah
				inc		edx
				mov		ecx, edx
				ret
			.ELSE
				mov		ecx, edx
				ret
			.ENDIF
		.ELSEIF	al==0Ah
			inc		edx
			mov		ecx, edx
			sub		eax, lpStart
			ret
		.ENDIF
	inc		edx
	.ENDW
	;still no CR/LF/CRLF found, so this is the last line
	xor		ecx, ecx
	mov		eax, edx
	sub		eax, lpStart
ret
FindSourceLine	endp

end start